package com.fp.frontend.controller.pgeneral.gene;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import com.fp.dto.Request;
import com.fp.dto.Response;
import com.fp.dto.query.DtoQuery;
import com.fp.dto.save.DtoSave;
import com.fp.frontend.controller.AbstractController;
import com.fp.frontend.helper.MessageHelper;
import com.fp.persistence.pgeneral.gene.TgeneBranch;

/**
 * Clase controladora del bean TgeneCatalogDetail.
 *
 * @author Jorge Vaca.
 * @version 2.1
 */
@ManagedBean
@ViewScoped
public class BranchController extends AbstractController<TgeneBranch> {

    private static final long serialVersionUID = 1L;

    public BranchController() throws Exception {
        super(TgeneBranch.class);
    }

    @PostConstruct
    private void postconstruct() {
        this.init();
        // Inicializa autoconsulta
        super.startQuery();

    }

    /**
     * Incializa el controlador, cuando se esta utilizando una pagina que utliza
     * el controlador.
     */
    private void init() {
        try {
            this.recperpage = 10; // Cambiar al # reg a mirar.
            this.lrecord = new ArrayList<>();
            this.beanalias = "TGENEBRANCH";
        } catch (Exception e) {
            MessageHelper.setMessageError(e);
        }
    }

    /**
     * Inicializa las paginas en la consulta
     */
    public void initRecPage() {
        this.page = 0;
        this.recperpage = 10;
    }

    @Override
    public void create() {
        try {
            super.create();
            this.record.getPk().setCompanycode(super.getLoginController().getRequest().getCompany());
        } catch (Exception ex) {

        }
    }

    @SuppressWarnings("unchecked")
    @Override
    protected void querydatabase() {
        try {
            //super.getMfilters().put("pk.branchcode", "!=0");
            if (super.getMfilters().get("pk.companycode") == null || super.getMfilters().get("pk.companycode").equals("")) {
                super.addFilter("pk.companycode", super.getLoginController().getRequest().getCompany().toString());
            }

            DtoQuery dto = super.getDtoQuery(true);
            dto.setOrderby("t.pk.branchcode");

            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(this.beanalias, dto); // permite adicionar mas de una tabla.

            Request request = this.callerhelper.getRequest();
            request.setQueryTables(mtables);

            Response resp = this.callerhelper.executeQuery(request);

            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                this.lrecord = new ArrayList<TgeneBranch>();
                MessageHelper.setMessageError(resp);
            } else {
                this.lrecord = (List<TgeneBranch>) resp.get(this.beanalias);
                super.postQuery(this.lrecord);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    @Override
    public void save() {
        try {
            DtoSave dtosave = super.getDtoSave();
            dtosave.setReturnpk(true); // Para que el core devuelva el pk de los registros nuevos.
            HashMap<String, DtoSave> msave = new HashMap<String, DtoSave>();

            Request request = this.callerhelper.getRequest();
            msave.put(this.beanalias, dtosave); // adicionar metadata de mantenimiento para cada tabla.

            request.setSaveTables(msave);
            Response resp = this.callerhelper.executeSave(request);
            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) == 0) {
                this.postCommit(resp);
                MessageHelper.setMessageInfo(resp);
            } else {
                MessageHelper.setMessageError(resp);
            }
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    public static List<TgeneBranch> find(String company) {
        try {
            BranchController bc = new BranchController();
            bc.init();
            bc.recperpage = 300;
            bc.addFilter("pk.companycode", company);
            bc.querydatabase();
            if (bc.lrecord != null && !bc.lrecord.isEmpty()) {
                return bc.lrecord;
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }

    }
}
